package org.jboss.jbpm.webapp;

import java.util.HashMap;
import java.util.Map;

import javax.ejb.Singleton;
import javax.inject.Named;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.io.impl.UrlResource;
import org.drools.runtime.StatefulKnowledgeSession;
import org.jbpm.examples.quickstarts.Person;

@Singleton
@Named
public class Runner
{
   private int timesRun = 0;

   private KnowledgeBase kbase = null;

   public void runIt()
   {
      try
      {
         if (kbase == null)
         {
            // load up the knowledge base
            kbase = readKnowledgeBase();
         }
         StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
         Map<String, Object> params = new HashMap<String, Object>();
         Person p = new Person("Maciej Swiderski");
         params.put("person", p);
         ksession.startProcess("com.sample.script", params);
      }
      catch (Throwable t)
      {
         t.printStackTrace();
      }
      timesRun++;
   }

   private static KnowledgeBase readKnowledgeBase() throws Exception
   {
      String url = "http://localhost:8080/drools-guvnor/org.drools.guvnor.Guvnor/package/defaultPackage/LATEST";

      UrlResource resource = (UrlResource) ResourceFactory.newUrlResource(url);
      resource.setBasicAuthentication("enabled");
      resource.setUsername("guest");
      resource.setPassword("guest");

      KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
      kbuilder.add(resource, ResourceType.PKG);

      return kbuilder.newKnowledgeBase();
   }

   public int getTimesRun()
   {
      return timesRun;
   }

   public void setTimesRun(int timesRun)
   {
      this.timesRun = timesRun;
   }
}
